#include <fpp.h>

#if STDC
void
dofile(const char *filename)
#else /* NOT STDC */
void
dofile(filename)
const char *filename;
#endif /* STDC */
{
    if (filename == (const char*)NULL)
    {
	fpp_name = STDIN;
	fpp_infile = stdin;
    }
    else
    {
	fpp_name = filename;
	fpp_infile = fopen(fpp_name,"r");
    }

    set_src_form(fpp_name);

    dodef2("__FILE__",fpp_name,1);

    if (fpp_infile == (FILE*)NULL)
	error("Cannot open input file [", fpp_name, "]", 0);
    else
    {
	FNR = 0;
	if (fpp_debug)
	{
	    FPRINTF(stddbg,"%s:DEBUG: Processing file [%s]\n",
		    fpp_dbgprefix(), fpp_name);
	    FFLUSH(stddbg);
	}
	process();
	if (level > 0)
	{
	    char buffer[sizeof("18446744073709551615")+1]; /* 2^64 - 1 */
	    (void)sprintf(buffer, "%d", level);
	    error(buffer, " unclosed if statements at line(s)", "", 1);
	}

	if (fpp_infile != stdin)
	{
	    (void)fclose(fpp_infile);
	    fpp_infile = (FILE*)NULL;
	}
    }
}
