#=======================================================================
# Makefile for fpp for Turbo C on IBM PC DOS.
#
# Current target list:
#	all		build fpp.exe
#	clean		delete unnecessary files after build
#	clobber		delete everything make built
#	distclean	same as clobber
#	fpp.exe		build Fortran preprocessor
#	fpplib.lib	build link library
#	mostlyclean	same as clean
#	realclean	same as clobber
#
# [21-May-2001] -- update for fpp-3.0.0
# [11-Dec-1993]
#=======================================================================

CC		= tcc

# -A	ANSI compatibility
# -G	optimize for speed
# -M	linker map (need for .sym files for debugging)
# -N	stack overflow check
# -O	optimize jumps
# -Z	optimize redundant loads
# -ml	large memory model
# -v	Turbo debugger symbols
# -y	line numbers for debugging
#
# Note that -DFOO is like -DFOO=' ', instead of -DFOO=1, sigh....
CFLAGS		= -A -N -ml -v -y $(XCFLAGS)
CFLAGS		= -A -N -ml $(XCFLAGS)

FPPLIB		= fpplib.lib

LIBOBJS         = concat.obj cuseri.obj defined.obj doarg.obj dodef.obj \
		  dodef2.obj dofile.obj doundef.obj dtos.obj error.obj \
		  eval.obj expand.obj expr.obj factor.obj fpp.obj getdef.obj \
		  gethst.obj getline.obj getname.obj hash.obj ident.obj \
		  init.obj inst.obj ismacro.obj isppline.obj lookup.obj \
		  macrolin.obj matchexp.obj name.obj normalli.obj number.obj \
		  power.obj ppline.obj process.obj prtchk.obj quit.obj \
		  setsrc.obj strdup.obj stricmp.obj strnic.obj term.obj \
		  tokenize.obj trim.obj version.obj warning.obj

LIBPGM		= tlib

LIBS		= $(TCWILD) $(FPPLIB)

RM		= del

# wildargs.obj supplies code for run-time wildcard argument expansion
# NB: Must be in upper-case to avoid interpretation of \t as escape sequence
DRIVE		= S:
TCWILD		= $(DRIVE)\SYS\TC\WILDARGS.OBJ

XCFLAGS		=

#=======================================================================

.SUFFIXES:

.SUFFIXES:	.obj .c

# Rules...

.c.obj:
	$(CC) -c $(CFLAGS) $*.c >$*.cer

#=======================================================================

all:	fpp.exe


clean mostlyclean:
	-$(RM) *.i
	-$(RM) *.obj

clobber distclean realclean:	clean
	-$(RM) fpp.exe 
	-$(RM) $(FPPLIB)

fpp.exe:	fpp.obj $(FPPLIB)
	$(CC) $(CFLAGS) -efpp.exe fpp.obj $(LIBS)

ADD		= $(LIBPGM) $(FPPLIB)

$(FPPLIB):	$(LIBOBJS)
	-$(RM) $(FPPLIB)
	$(ADD) -+ concat.obj -+ cuseri.obj -+ defined.obj -+ doarg.obj
	$(ADD) -+ dodef.obj -+ dodef2.obj -+ dofile.obj -+ doundef.obj
	$(ADD) -+ dtos.obj -+ error.obj -+ eval.obj -+ expand.obj
	$(ADD) -+ expr.obj -+ factor.obj -+ getdef.obj
	$(ADD) -+ gethst.obj -+ getline.obj -+ getname.obj -+ hash.obj
	$(ADD) -+ ident.obj -+ init.obj -+ inst.obj -+ ismacro.obj
	$(ADD) -+ isppline.obj -+ lookup.obj -+ macrolin.obj
	$(ADD) -+ matchexp.obj -+ name.obj -+ normalli.obj -+ number.obj
	$(ADD) -+ power.obj -+ ppline.obj -+ process.obj -+ prtchk.obj 
	$(ADD) -+ quit.obj -+ setsrc.obj -+ strdup.obj -+ stricmp.obj 
	$(ADD) -+ strnic.obj -+ term.obj -+ tokenize.obj -+ trim.obj
	$(ADD) -+ version.obj -+ warning.obj
#=======================================================================
